#include <iostream>
#include <algorithm>
#include <vector>
#include <queue>

using namespace std;

bool comparator1 (vector<int> a, vector<int> b) {
    return (a[1] < b[1]);
}
bool comparator3 (vector<int> a, vector<int> b) {
    return (a[0] < b[0]);
}


bool comparator2 (queue<pair<int, int>> a, queue<pair<int, int>> b) {

    if (a.front().second == b.front().second) return a.front().first < b.front().first;
    else return (a.front().second < b.front().second);
}

bool em(vector<queue<pair<int, int>>> a) {
    bool r = true;
    for (queue<pair<int, int>> i : a) if (!i.empty()) r = false;
    return r;
}

int main(void) {
    int n, m, time = 0, p = 0;
    cin >> n >> m;
    vector<vector<int>> emp(n, vector<int> (4));
    for (int i = 0; i < n; ++i) {
            cin >> emp[i][1] >> emp[i][2];
            --emp[i][1];
            --emp[i][2];
            emp[i][0] = i;
            emp[i][3] = 1000000;
    }
    stable_sort(emp.begin(), emp.end(), comparator1);
    vector<queue<pair<int, int>>> build(m);
    for (vector<int> i : emp) build[i[2]].push({i[0], i[1]});
    stable_sort(emp.begin(), emp.end(), comparator3);
    //sort(build.begin(), build.end(), comparator2);
    /*for (int i = m - 1; i >= 0; --i) {
        while (!build[i].empty()) {
            cout << build[i].front().first << " ";
            build[i].pop();
        }
        cout << "\n";
    }
    */

    while(!em(build)) {
        int act = 1;
        for (int i = 1; i < m; ++i) {
                if (!build[i].empty() && build[i].front().second < build[act].front().second)
                    act = i;
        }
        //cout << act;
        //for (int i =0; i < 100; --i) int q = 1;
        if(time >= build[act].front().second) time += act;
        else time = build[act].front().second + act;
        //cout << "act: " << act << " time: " << time << "\n";
        while (act > 0) {
            while(!build[act].empty() && build[act].front().second <= time) {
                emp[build[act].front().first][3] = time + act;
                build[act].pop();
            }
            //for (int i =0; i < 100; --i) int q = 1;
            ++time;
            --act;
            //cout << "actdown: " << act << " time: " << time << "\n";

        }
    }
    for (vector<int> i : emp) cout << i[3] << endl;

}
