#include <iostream>
#include <algorithm>
#include <vector>
#include <queue>

using namespace std;

int bfs(int i, vector<vector<int>> g) {
    int n = g.size();
    vector<int> used (n, 0);
    queue<int> v;
    v.push(i);
    used[i] = 1;
    while (!v.empty()) {
        for (int t = 0; t < n; ++t) if (g[v.front()][t] != -1 && used[t] == 0) {
                v.push(t);
                used[t] = used[v.front()] + 1;
        }
        v.pop();
    }
    int m = 0;
    for (int i = 0; i < n; ++i) if (used[i] > m)  m = used[i];
    //cout << m << "\n";
    return m;
}

int main(void) {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> g(n, vector<int> (n, -1));
    vector<bool> l(n, true);
    vector<int> r(n, 0);
    l[0] = false;
    g[0][0] = 1;
    for (int i = 0; i < n - 1; ++i) {
        int p;
        cin >> p;
        g[i + 1][p - 1] = 1;
        g[p - 1][i + 1] = 1;
        g[i + 1][i + 1] = 0;
        l[p - 1] = false;
    }
    //for (int i = 0; i < n; ++i) {for (int j = 0; j < n; ++j) cout << g[i][j] << " "; cout << "\n";}
    for (int i = 0; i < n; ++i) if(l[i]) r[i] = max(r[i], bfs(i, g));
    int y = 0;
    for (int i = 0; i < n; ++i) if (r[i] > y) y = r[i];
    cout << y;
}
